package br.usp.nds.remote.persistencia;

import java.util.Date;
import java.util.List;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

import br.usp.nds.remote.integracao.ProcessadorMensagem;

@Entity
public class Mensagem extends Entidade {

	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
	private int codigo;
	@Temporal(TemporalType.TIMESTAMP)
	private Date data;
	@Column(length = 1000)
	private String mensagem;
	
	public void registrar() {
		new ProcessadorMensagem()
				.registrar(mensagem)
				.processar()
				.verificarEventos();
	}
	
	public List<Mensagem> listar() {
		return em.createQuery("SELECT m FROM Mensagem m ORDER BY m.data DESC").getResultList();
	}
	
	public int getCodigo() {
		return codigo;
	}
	public void setCodigo(int codigo) {
		this.codigo = codigo;
	}
	public Date getData() {
		return data;
	}
	public void setData(Date data) {
		this.data = data;
	}
	public String getMensagem() {
		return mensagem;
	}
	public void setMensagem(String mensagem) {
		this.mensagem = mensagem;
	}
}
