package br.usp.nds.remote.persistencia;

import java.util.List;

import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.ManyToOne;
import javax.persistence.Transient;

@Entity
public class SubsistemaSvg extends Entidade {

	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
	private Integer codigo;
	@ManyToOne
	private Embarcacao embarcacao;
	@ManyToOne
	private Subsistema subsistema;
	private String svg;
	@Transient
	private String codigosEmbarcacoes;

	public SubsistemaSvg consultar() {
		return em.find(SubsistemaSvg.class, codigo);
	}
	
	public List<SubsistemaSvg> listar() {
		return em.createQuery("SELECT s FROM SubsistemaSvg s WHERE s.embarcacao.codigo IN (" + codigosEmbarcacoes + ")").getResultList();
	}
	
	public void excluir() {
		em.remove(em.find(SubsistemaSvg.class, codigo));
	}
	
	public void salvar() {
		if (codigo == null) {
			em.persist(this);
		} else {
			em.merge(this);
		}
	}
	
	public String getCodigosEmbarcacoes() {
		return codigosEmbarcacoes;
	}

	public void setCodigosEmbarcacoes(String codigosEmbarcacoes) {
		this.codigosEmbarcacoes = codigosEmbarcacoes;
	}

	public Integer getCodigo() {
		return codigo;
	}
	public void setCodigo(Integer codigo) {
		this.codigo = codigo;
	}
	public Embarcacao getEmbarcacao() {
		return embarcacao;
	}
	public void setEmbarcacao(Embarcacao embarcacao) {
		this.embarcacao = embarcacao;
	}
	public Subsistema getSubsistema() {
		return subsistema;
	}
	public void setSubsistema(Subsistema subsistema) {
		this.subsistema = subsistema;
	}
	public String getSvg() {
		return svg;
	}
	public void setSvg(String svg) {
		this.svg = svg;
	}
}
