/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package br.usp.nds.remote.servico;

import java.util.LinkedList;
import java.util.List;

import javax.ws.rs.core.MultivaluedMap;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlSeeAlso;

import br.usp.nds.remote.persistencia.Aquisicao;
import br.usp.nds.remote.persistencia.Embarcacao;
import br.usp.nds.remote.persistencia.Mensagem;
import br.usp.nds.remote.persistencia.Sensor;

/**
 * 
 * @author 316030740116
 */
@XmlRootElement
@XmlSeeAlso({
	Aquisicao.class,
	Embarcacao.class,
	Sensor.class,
	Mensagem.class
})
public class Retorno {

	private List item;
	private String tipo;
	private String mensagem;

	public static Retorno criar(Object obj, MultivaluedMap<String, String> params) {
		Retorno result = null;
		if (obj instanceof List) {
			result = new Retorno((List) obj, "OK", null);
		} else {
			List item = new LinkedList();
			item.add(obj);
			result = new Retorno(item, "OK", null);
		}
		return result;
	}

	public static Retorno criarErro(String mensagem) {
		return new Retorno(null, "ERRO", mensagem);
	}

	public Retorno() {
	}

	public Retorno(List item, String tipo, String mensagem) {
		this.item = item;
		this.tipo = tipo;
		this.mensagem = mensagem;
	}

	public List getItem() {
		return item;
	}

	public void setItem(List item) {
		this.item = item;
	}

	public String getMensagem() {
		return mensagem;
	}

	public void setMensagem(String mensagem) {
		this.mensagem = mensagem;
	}

	public String getTipo() {
		return tipo;
	}

	public void setTipo(String tipo) {
		this.tipo = tipo;
	}
}
